// WinModDlg.cpp : Implementierungsdatei
//

#include "stdafx.h"
#include <stdio.h>
#include <io.h>
#include <fcntl.h>
#include <math.h>
#include "WinModFileTypes.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


/////////////////////////////////////////////////////////////////////////////
// CAboutDlg-Dialogfeld fr Anwendungsbefehl "Info"

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialogfelddaten
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// Vom Klassenassistenten generierte berladungen virtueller Funktionen
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV-Untersttzung
	//}}AFX_VIRTUAL

// Implementierung
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// Keine Nachrichten-Handler
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWinModDlg Dialogfeld

CWinModDlg::CWinModDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CWinModDlg::IDD, pParent), m_cfFixedFont(NULL), MyPenGray(NULL)
{
	//{{AFX_DATA_INIT(CWinModDlg)
	//}}AFX_DATA_INIT
	// Beachten Sie, dass LoadIcon unter Win32 keinen nachfolgenden DestroyIcon-Aufruf bentigt
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	MyPenGray = new CPen(PS_SOLID, 1, RGB(125,125,125));
}

CWinModDlg::~CWinModDlg()
{
	if (m_cfFixedFont) 
	{
		m_cfFixedFont->Detach();
		delete m_cfFixedFont;
	}
	if (MyPenGray) delete MyPenGray;
}

void CWinModDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CWinModDlg)
	DDX_Control(pDX, IDC_CHECK_linFrequ, m_CheckUseLinearFrequency);
	DDX_Control(pDX, IDC_CHECK_UseWaveOut, m_UseWaveOut);
	DDX_Control(pDX, IDC_PeekMeter, m_PeekMeter);
	DDX_Control(pDX, IDC_CHECK_WideStereo, m_WideStereoC);
	DDX_Control(pDX, IDC_CHECK_LoopsAllowed, m_CheckLoopsAllowedC);
	DDX_Control(pDX, IDC_CHECK_ISP, m_CheckISPC);
	DDX_Control(pDX, IDC_CHECK_Clipping, m_CheckClippingC);
	DDX_Control(pDX, IDC_CHECK_CLICK, m_CheckClickC);
	DDX_Control(pDX, IDC_TrackerName, m_TrackerNameC);
	DDX_Control(pDX, IDC_SongName, m_SongNameC);
	DDX_Control(pDX, IDC_LoadError, m_LoadErrorC);
	DDX_Control(pDX, IDC_FileName, m_FileNameC);
	DDX_Control(pDX, IDC_Time, m_PlayerTimeC);
	DDX_Control(pDX, IDC_TickCount, m_CPUUTILC);
	DDX_Control(pDX, IDC_Speed, m_ActSpeedC);
	DDX_Control(pDX, IDC_BPM, m_ActBPMC);
	DDX_Control(pDX, IDC_ActRow, m_ActRowC);
	DDX_Control(pDX, IDC_ActPatternIndex, m_ActPatternIndexC);
	DDX_Control(pDX, IDC_ActPattern, m_ActPatternC);
	DDX_Control(pDX, IDC_Button_Next, m_NextButton);
	DDX_Control(pDX, IDC_TheWaveR, m_TheWaveR);
	DDX_Control(pDX, IDC_TheWaveL, m_TheWaveL);
	DDX_Control(pDX, IDC_SLIDER_preAmp, m_SliderPreAmp);
	DDX_Control(pDX, IDC_COMBO_Bufferms, m_Combo_Bufferms);
	DDX_Control(pDX, IDC_COMBO_nSamples, m_Combo_nSamples);
	DDX_Control(pDX, IDC_COMBO_Channels, m_Combo_Channels);
	DDX_Control(pDX, IDC_COMBO_PlayerFrequ, m_Combo_PlayerFrequenzy);
	DDX_Control(pDX, IDC_Button_Stop, m_StopButton);
	DDX_Control(pDX, IDC_Button_Pause, m_PauseButton);
	DDX_Control(pDX, IDC_Button_Play, m_PlayButton);
	DDX_Control(pDX, IDC_Button_FF, m_FFButton);
	DDX_Control(pDX, IDC_Button_RW, m_RWButton);
	DDX_Control(pDX, IDC_ListSampleNames, m_SampleNames);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CWinModDlg, CDialog)
	//{{AFX_MSG_MAP(CWinModDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_COMMAND(ID_Datei_Beenden, OnDateiBeenden)
	ON_COMMAND(ID_Hilfe_Info, OnHilfeInfo)
	ON_COMMAND(ID_Datei_OpenFile, OnDateiOpenFile)
	ON_COMMAND(ID_DATEI_INSTRUMENTE, OnDateiInstrumente)
	ON_LBN_DBLCLK(IDC_ListSampleNames, OnDblclkListSampleNames)
	ON_BN_CLICKED(IDC_CHECK_ISP, OnCheckIsp)
	ON_BN_CLICKED(IDC_CHECK_WideStereo, OnCHECKWideStereo)
	ON_BN_CLICKED(IDC_CHECK_Clipping, OnCHECKClipping)
	ON_BN_CLICKED(IDC_Button_Pause, OnButtonPause)
	ON_BN_CLICKED(IDC_Button_Play, OnButtonPlay)
	ON_BN_CLICKED(IDC_Button_Stop, OnButtonStop)
	ON_BN_CLICKED(IDC_CHECK_CLICK, OnCheckClick)
	ON_BN_CLICKED(IDC_Button_RW, OnButtonRW)
	ON_BN_CLICKED(IDC_Button_FF, OnButtonFF)
	ON_BN_CLICKED(IDC_Button_Next, OnButtonNext)
	ON_WM_DROPFILES()
	ON_COMMAND(ID_Datei_Pattern, OnDateiPattern)
	ON_BN_CLICKED(IDC_CHECK_LoopsAllowed, OnCHECKLoopsAllowed)
	ON_BN_CLICKED(IDC_CHECK_UseWaveOut, OnCHECKUseWaveOut)
	ON_BN_CLICKED(IDC_CHECK_linFrequ, OnCHECKlinFrequ)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWinModDlg Nachrichten-Handler

char *GetParam(char *ErgStr, char *ParaStr, int count)
{
	char *s,*s2;
	int i;
	bool InString=false;

	i=0; s=ParaStr;
	while (*s && i<count)
	{
		if (*s=='\"') InString=!InString;
		if (*s==' ' && !InString) i++;
		s++;
	}
	while (*s==' ') s++;
	s2=s;
	while (*s2 && (*s2!=' ' || InString)) 
	{
		if (*s2=='\"') InString=!InString;
		s2++;
	}

	if (*s) 
	{
		if (*s=='\"') s++;
		if (*(s2-1)=='\"') s2--;
		strncpy(ErgStr,s,s2-s);
		ErgStr[s2-s]=0;
	}
	else *ErgStr=0;
	return(ErgStr);
}

/*void CWinModDlg::OnTimer(UINT nIDEvent) 
{
	AusgabeDaten();
	CDialog::OnTimer(nIDEvent);
}*/

bool inTimer = false;

void CALLBACK EXPORT MyTimerProc(
   HWND hWnd,      // handle of CWnd that called SetTimer
   UINT nMsg,      // WM_TIMER
   UINT nIDEvent,  // timer identification
   DWORD dwTime    // system time
)
{
	if (inTimer) return;
	inTimer=true;
	extern CWinModApp theApp;
	((CWinModDlg *)theApp.m_pMainWnd)->AusgabeDaten();
	inTimer=false;
}

BOOL CWinModDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Hinzufgen des Menbefehls "Info..." zum Systemmen.

	// IDM_ABOUTBOX muss sich im Bereich der Systembefehle befinden.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Symbol fr dieses Dialogfeld festlegen. Wird automatisch erledigt
	//  wenn das Hauptfenster der Anwendung kein Dialogfeld ist
	SetIcon(m_hIcon, TRUE);			// Groes Symbol verwenden
	SetIcon(m_hIcon, FALSE);		// Kleines Symbol verwenden
	
	// ZU ERLEDIGEN: Hier zustzliche Initialisierung einfgen
	int i;
	extern CWinModApp theApp; // Das Applicationopjekt
	HICON hIconPlayButton, hIconPauseButton, hIconStopButton, hIconFF, hIconRW, hIconNext;

	hIconPlayButton=theApp.LoadIcon(MAKEINTRESOURCE(IDI_ICON_PlayOnceButton));
	hIconPauseButton=theApp.LoadIcon(MAKEINTRESOURCE(IDI_ICON_Pause));
	hIconStopButton=theApp.LoadIcon(MAKEINTRESOURCE(IDI_ICON_Stop));
	hIconFF=theApp.LoadIcon(MAKEINTRESOURCE(IDI_ICON_FF));
	hIconRW=theApp.LoadIcon(MAKEINTRESOURCE(IDI_ICON_RW));
	hIconNext=theApp.LoadIcon(MAKEINTRESOURCE(IDI_ICON_NEXT));
	m_PlayButton.SetIcon(hIconPlayButton);
	m_PauseButton.SetIcon(hIconPauseButton);
	m_StopButton.SetIcon(hIconStopButton);
	m_FFButton.SetIcon(hIconFF);
	m_RWButton.SetIcon(hIconRW);
	m_NextButton.SetIcon(hIconNext);
	m_SliderPreAmp.SetRange(1,1024, true);
	m_SliderPreAmp.SetPos(512);
	m_SliderPreAmp.SetTicFreq(64);
	m_MaxPeekL=m_MaxPeekR=m_TimeForPeekL=m_TimeForPeekR=0;
	
	m_TheWaveL.GetClientRect(&m_ClientRectWaveBox);
	m_ClientRectWaveBox.top--;
	m_ClientRectFullWaveBox = m_ClientRectWaveBox;
	m_ClientRectWaveBox.bottom--; m_ClientRectWaveBox.right--; 
	m_DisplayFacY=((m_ClientRectWaveBox.bottom-m_ClientRectWaveBox.top)*LMULTI)/(unsigned long)(65535L);
	m_WaveBoxMiddle = m_ClientRectWaveBox.bottom-(32767*m_DisplayFacY/LMULTI);
	
	m_PeekMeter.GetClientRect(&m_ClientRectPeekMeter);
	m_ClientRectPeekMeter.top+=5;
	m_ClientRectPeekMeter.bottom-=5;
	m_PeekWidth=10;
	m_PeekX1 = m_ClientRectPeekMeter.left+5;
	m_PeekX2 = m_ClientRectPeekMeter.right-5-m_PeekWidth;
	m_Peek_h = m_ClientRectPeekMeter.bottom-m_ClientRectPeekMeter.top;

	DrawNoMore=Pause=PlayList=PlayNextFile=NextFile=false;
	PlayerDone=true;

	// Init ComboBoxes
	char TheString[20];
	
	for (i=0; i<nComboFrequenzies; i++)
	{
		sprintf(TheString,"%u Hz",Frequenzies[i]);
		m_Combo_PlayerFrequenzy.AddString(TheString);
	}
	for (i=0; i<nComboBufferms; i++)
	{
		sprintf(TheString,"%u ms",Bufferms[i]);
		m_Combo_Bufferms.AddString(TheString);
	}
	for (i=0; i<nComboChannels; i++)
	{
		sprintf(TheString,"%u",Channels[i]);
		m_Combo_Channels.AddString(TheString);
	}
	for (i=0; i<nComboBitPerSamples; i++)
	{
		sprintf(TheString,"%u Bit",BitPerSamples[i]);
		m_Combo_nSamples.AddString(TheString);
	}
	
	inTimer = false;
	SetTimer(1,1,MyTimerProc);
	
    m_cfFixedFont = new CFont;
	m_cfFixedFont->CreateStockObject(SYSTEM_FIXED_FONT);

	m_SampleNames.SetFont(m_cfFixedFont, true); // redraw = true

	getConfigFromRegistry();

	if (*(theApp.m_lpCmdLine)) 
	{
		char FileName[256];

		LoadaFile(GetParam(FileName,theApp.m_lpCmdLine,0));
		OnButtonPlay();
	}

	return TRUE;  // Geben Sie TRUE zurck, auer ein Steuerelement soll den Fokus erhalten
}

int CWinModDlg::getValueFromKey(HKEY handle, LPCTSTR lpValueName)
{
	DWORD type;
	BYTE data[4];
	DWORD len =4;
	int ccode = RegQueryValueEx(handle, lpValueName, 0, &type, (LPBYTE) &data, &len);
	if (ccode) return -1;
	return ((int *)data)[0];
}

int CWinModDlg::setValueToKey(HKEY handle, LPCTSTR lpValueName, DWORD value)
{
	return RegSetValueEx(handle, lpValueName, 0, REG_DWORD, (LPBYTE) &value, sizeof(DWORD));
}

int CWinModDlg::getConfigFromRegistry()
{
	int ccode;
	HKEY keyHandle = NULL;

	if (ccode =  RegCreateKeyEx(HKEY_CURRENT_USER, WINMOD_REG_KEY, 0, NULL, REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, &keyHandle, NULL)) return ccode;
	
	int val = getValueFromKey(keyHandle, TEXT("PlayerFrequenzy"));
	if (val>=0 && val<nComboFrequenzies) m_Combo_PlayerFrequenzy.SetCurSel(val);
	else m_Combo_PlayerFrequenzy.SetCurSel(DefaultFrequenzy);

	val = getValueFromKey(keyHandle, TEXT("PlayerBuffers"));
	if (val>=0 && val<nComboBufferms) m_Combo_Bufferms.SetCurSel(val);
	else m_Combo_Bufferms.SetCurSel(DefaultBufferms);

	val = getValueFromKey(keyHandle, TEXT("PlayerChannels"));
	if (val>=0 && val<nComboChannels) m_Combo_Channels.SetCurSel(val);
	else m_Combo_Channels.SetCurSel(DefaultChannel);

	val = getValueFromKey(keyHandle, TEXT("PlayerSamples"));
	if (val>=0 && val<nComboBitPerSamples) m_Combo_nSamples.SetCurSel(val);
	else m_Combo_nSamples.SetCurSel(DefaultSamples);


	val = getValueFromKey(keyHandle, TEXT("ISP"));
	if (val!=-1) PlayerISP=(val!=0);
	m_CheckISPC.SetCheck(PlayerISP);
	
	val = getValueFromKey(keyHandle, TEXT("WideStereo"));
	if (val!=-1) PlayerWideStereo=(val!=0);
	m_WideStereoC.SetCheck(PlayerWideStereo);
	
	val = getValueFromKey(keyHandle, TEXT("UseWaveOut"));
	if (val!=-1) useWaveOut=(val!=0);
	m_UseWaveOut.SetCheck(m_InternalUseWaveOut=useWaveOut);
	
	val = getValueFromKey(keyHandle, TEXT("Clipping"));
	if (val!=-1) PlayerClipping=(val!=0);
	m_CheckClippingC.SetCheck(PlayerClipping);
	
	val = getValueFromKey(keyHandle, TEXT("Click"));
	if (val!=-1) PlayerClick=(val!=0);
	m_CheckClickC.SetCheck(PlayerClick);
	
	val = getValueFromKey(keyHandle, TEXT("LoopsAllowed"));
	if (val!=-1) PlayerLoopsAllowed=(val!=0);
	m_CheckLoopsAllowedC.SetCheck(PlayerLoopsAllowed);
	
	if (keyHandle != NULL) RegCloseKey(keyHandle);
	return ccode;
}

int CWinModDlg::writeConfigToRegistry()
{
	int ccode;
	HKEY keyHandle = NULL;

	if (ccode =  RegCreateKeyEx(HKEY_CURRENT_USER, WINMOD_REG_KEY, 0, NULL, REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, &keyHandle, NULL)) return ccode;
	
	setValueToKey(keyHandle, TEXT("PlayerFrequenzy"), m_Combo_PlayerFrequenzy.GetCurSel());
	setValueToKey(keyHandle, TEXT("PlayerBuffers"), m_Combo_Bufferms.GetCurSel());
	setValueToKey(keyHandle, TEXT("PlayerChannels"), m_Combo_Channels.GetCurSel());
	setValueToKey(keyHandle, TEXT("PlayerSamples"), m_Combo_nSamples.GetCurSel());
	setValueToKey(keyHandle, TEXT("ISP"), m_CheckISPC.GetCheck());
	setValueToKey(keyHandle, TEXT("WideStereo"), m_WideStereoC.GetCheck());
	setValueToKey(keyHandle, TEXT("UseWaveOut"), m_UseWaveOut.GetCheck());
	setValueToKey(keyHandle, TEXT("Clipping"), m_CheckClippingC.GetCheck());
	setValueToKey(keyHandle, TEXT("Click"), m_CheckClickC.GetCheck());
	setValueToKey(keyHandle, TEXT("LoopsAllowed"), m_CheckLoopsAllowedC.GetCheck());
	
	if (keyHandle != NULL) RegCloseKey(keyHandle);
	return ccode;
}

void CWinModDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// Wollen Sie Ihrem Dialogfeld eine Schaltflche "Minimieren" hinzufgen, bentigen Sie 
//  den nachstehenden Code, um das Symbol zu zeichnen. Fr MFC-Anwendungen, die das 
//  Dokument/Ansicht-Modell verwenden, wird dies automatisch fr Sie erledigt.

void CWinModDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // Gertekontext fr Zeichnen

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Symbol in Client-Rechteck zentrieren
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Symbol zeichnen
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// Die Systemaufrufe fragen den Cursorform ab, die angezeigt werden soll, whrend der Benutzer
//  das zum Symbol verkleinerte Fenster mit der Maus zieht.
HCURSOR CWinModDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

// Eingene Routinen:
// Datei Men:
void CWinModDlg::OnDateiBeenden() 
{
	OnOK();
}

void CWinModDlg::OnHilfeInfo() 
{
	CAboutDlg InfoDlg;

	InfoDlg.DoModal();
}

void CWinModDlg::ClosePlayListFile()
{
	if (PlayList)
	{
		PlayList=false;
		_close(PlayListHandle);
	}
}

void CWinModDlg::OpenPlayListFile(char *FileName)
{
	char *s, ext[4];
	extern char *strupper(char *str);	// In Mod_Loader.cpp

	if (PlayList) return;				// PlayList bereits offen
	s=strrchr(FileName,'.');
	if (!s) return;
	if (!(*s)) return;					// Keine Extension
	s++; 
	strncpy(ext,s,3); ext[3]=0;
	strupr(ext);
	if (strcmp(ext,"LST")) return;		// Kein ListFile

	PlayListHandle=_open(FileName, _O_BINARY | _O_RDONLY);
	if (PlayListHandle==-1) return;		// Datei nicht gefunden

	PlayList=true;
	PlayNextPiece(); 
}

void CWinModDlg::PlayNextPiece()
{
	char FileName[500],c;
	int NameIndex;

	NameIndex=0;
	while (!eof(PlayListHandle) && NameIndex<499)
	{
		_read(PlayListHandle, &c, 1);
		if (c=='\n') break;
		if (c=='\r') continue;
		FileName[NameIndex++]=c;
	}
	FileName[NameIndex]=0;
	if (eof(PlayListHandle)) ClosePlayListFile();
	if (NameIndex) LoadaFile(FileName);
}

void CWinModDlg::LoadaFile(char *FileName)
{
	extern CWinModApp theApp;
	int Error;
	long ErrorValue;

	theApp.DoWaitCursor(1);
	if (!PlayList) 
	{ 
		OpenPlayListFile(FileName); 
		if (PlayList) return; 
	}
	StopPlay();
	// Load the Mod
	GenModStruct(&ThisMod);
	DoRewind(false);	
	DoFastForward(false);
	Pause=false;

	// Fenster leeren
	m_SongNameC.SetWindowText("");
	m_FileNameC.SetWindowText("");
	m_SampleNames.ResetContent();
	m_LoadErrorC.SetWindowText("");
	m_TrackerNameC.SetWindowText("");

	// Ladeversuch...
	if (Read_ModFiles(FileName, *ThisMod, &Error, &ErrorValue))
	{
		unsigned int i;
		char TrackerName[1000],*s;
		
		// Die Felder updaten:
		m_SongNameC.SetWindowText(ThisMod->SongName);
		strcpy(TrackerName,FileName);
		s=strrchr(TrackerName,'\\');
		if (*s) s++; else s=TrackerName;
		
		char fileName[255]; strcpy(fileName, s);
		m_FileNameC.SetWindowText(fileName);
		
		sprintf(TrackerName, "WinMod V%s - %s", version, fileName);
		SetWindowText(TrackerName);

		// ListBox mit neuen Sampledaten fllen
		for (i=0; i<ThisMod->nSamples; i++)
			m_SampleNames.AddString(ThisMod->Samples[i].Name);

		if (Error==LOADERROR_MODSIZE)
		{
			char ErrorTxt[100];

			if (ErrorValue<0)
				sprintf(ErrorTxt, "Mod too short for %ld Bytes", ErrorValue*-1);
			else
				sprintf(ErrorTxt, "Mod too long for %ld Bytes", ErrorValue);

			m_LoadErrorC.SetWindowText(ErrorTxt);
		}
		else
		if (Error==LOADERROR_MODCORRUPT) m_LoadErrorC.SetWindowText("Mod is corrupt");
		else
		if (Error==LOADERROR_MODANZCHAN) m_LoadErrorC.SetWindowText("Mod has too many Channels");
		else m_LoadErrorC.SetWindowText("No Errors");

		sprintf(TrackerName,"%s [%s]", ThisMod->TrackerName, (!(*ThisMod->ModID))?"no ID":ThisMod->ModID);
		m_TrackerNameC.SetWindowText(TrackerName);
		PlayerUseLinearFrequency = !ThisMod->usesLinearFrequency;
		OnCHECKlinFrequ();
	}
	else
	{
		FreeModStruct(&ThisMod);
		if (Error==LOADERROR_UNSUPPORTED) m_LoadErrorC.SetWindowText("Unsupported File");
		else
		if (Error==LOADERROR_FILENOTFOUND) m_LoadErrorC.SetWindowText("File not found");
	}

	theApp.DoWaitCursor(-1);
}

void CWinModDlg::OnDateiOpenFile() 
{
	char FileName[500];		//Dateiname plus vollstndiger Pfad
	char FileTitle[100];	//Nur der Dateiname

	ClosePlayListFile();
	OPENFILENAME ofn;
	memset(&ofn, 0, sizeof(ofn));

	ofn.lStructSize = sizeof(ofn);
	ofn.hwndOwner = m_hWnd;
	ofn.hInstance = NULL;
	ofn.lpstrFilter = TEXT("Supported Files\0"
		                   "*.mod;*.nst;*.lst;*.stm;*.s3m;*.wow\0"
						   "MOD-Files [mod]\0"
						   "*.mod\0"
						   "NoiseTracker-Files [nst]\0"
						   "*.nst\0"
						   "Grave Composer [wow]\0"
						   "*.wow\0"
						   "ScreamTracker-Files [stm]\0"
						   "*.stm\0"
						   "ScreamTracker-Files [s3m]\0"
						   "*.s3m\0"
						   "Listfiles [lst]\0"
						   "*.lst\0"
						   "All files\0"
						   "*.*\0\0");
	ofn.lpstrCustomFilter = NULL;
	ofn.nMaxCustFilter = 0;
	ofn.nFilterIndex = 1;
	ofn.lpstrFile = FileName;
	ofn.nMaxFile = 499;
	ofn.lpstrFileTitle = FileTitle;
	ofn.nMaxFileTitle = 99;
	ofn.lpstrInitialDir = NULL;
	ofn.lpstrTitle = "open Mod-file";
	ofn.Flags = OFN_FILEMUSTEXIST | OFN_HIDEREADONLY;
	ofn.nFileOffset = 0;
	ofn.nFileExtension = 0;
	ofn.lpstrDefExt = TEXT("MOD");
	ofn.lCustData = 0;
	ofn.lpfnHook = NULL;
	ofn.lpTemplateName = NULL;

	*FileName=0;

	GetOpenFileName(&ofn);

	if (*FileName) LoadaFile(FileName);
}

void CWinModDlg::OnDateiInstrumente() 
{
	if (!ThisMod || !ThisMod->Samples) return;

	CWinModInsDlg InstrumentDlg;

	InstrumentDlg.ActSample=0;
	InstrumentDlg.DoModal();

	m_CheckISPC.SetCheck(PlayerISP);
	m_WideStereoC.SetCheck(PlayerWideStereo);
	m_CheckClippingC.SetCheck(PlayerClipping);
	m_CheckClickC.SetCheck(PlayerClick);
}

CWinModPatternDlg PatternDlg;

void CWinModDlg::OnDateiPattern() 
{
	if (!ThisMod) return;
	
	PatternDlg.DoModal();
}

void CWinModDlg::OnDblclkListSampleNames() 
{
	if (!ThisMod || !ThisMod->Samples) return;

	CWinModInsDlg InstrumentDlg;

	InstrumentDlg.ActSample=m_SampleNames.GetCurSel();
	InstrumentDlg.DoModal();
}

void CWinModDlg::DrawBufferSample()
{
	unsigned long i, Farbe1, Farbe2;
	long x,y1,y2,vall,valr;;
	unsigned long facx,suml=0,sumr=0;
	CClientDC dcl(&m_TheWaveL);
	CClientDC dcr(&m_TheWaveR);
	CClientDC dcp(&m_PeekMeter);
    CPen *OldPenl, *OldPenr;

	dcl.FillSolidRect( &m_ClientRectFullWaveBox, RGB(0,0,0));
	dcr.FillSolidRect( &m_ClientRectFullWaveBox, RGB(0,0,0));

	OldPenl=dcl.SelectObject( MyPenGray );
	OldPenr=dcr.SelectObject( MyPenGray );
	dcl.MoveTo(m_ClientRectWaveBox.right,m_WaveBoxMiddle);	
	dcl.LineTo(m_ClientRectWaveBox.left,m_WaveBoxMiddle);
	dcr.MoveTo(m_ClientRectWaveBox.right,m_WaveBoxMiddle);	
	dcr.LineTo(m_ClientRectWaveBox.left,m_WaveBoxMiddle);
	
	// Alten Pen zurcksetzen
	dcl.SelectObject(OldPenl);
	dcr.SelectObject(OldPenr);

	if (!PlayerDone)
	{
		facx=((m_ClientRectWaveBox.right-m_ClientRectWaveBox.left)*LMULTI)/BufferDataLen;
		for (i=0; i<BufferDataLen; i++)
		{
			x=m_ClientRectWaveBox.left+((facx*i)/LMULTI);

			// Da die StereoTabs u.U. bereits gefreed sind, hier aufpassen
			if (!StereoTabL || !StereoTabR) break;
			
			unsigned long c = labs(vall = StereoTabL[i]);
			if (c>suml) suml=c;
			c = labs(valr = StereoTabR[i]);
			if (c>sumr) sumr=c;

			y1=m_ClientRectWaveBox.bottom-(((vall+32767)*m_DisplayFacY)/LMULTI);
			y2=m_ClientRectWaveBox.bottom-(((valr+32767)*m_DisplayFacY)/LMULTI);
			Farbe1=labs(vall*255L/32767L);
			Farbe2=labs(valr*255L/32767L);
			
			dcl.SetPixel(x, (y1<m_ClientRectWaveBox.top)?m_ClientRectWaveBox.top:((y1>m_ClientRectWaveBox.bottom)?m_ClientRectWaveBox.bottom:y1), RGB(Farbe1,255-Farbe1,0));
			dcr.SetPixel(x, (y2<m_ClientRectWaveBox.top)?m_ClientRectWaveBox.top:((y2>m_ClientRectWaveBox.bottom)?m_ClientRectWaveBox.bottom:y2), RGB(Farbe2,255-Farbe2,0));
		}
	}
	else
	{
		DrawNoMore=true;
	}

	suml=((suml*m_Peek_h*LMULTI)/(unsigned long)(32767L))/LMULTI;
	if (suml>=m_Peek_h) suml=m_Peek_h-1;
	if (suml>m_MaxPeekL) 
	{
		m_MaxPeekL=suml;
		m_TimeForPeekL=10;
	}
	sumr=((sumr*m_Peek_h*LMULTI)/(unsigned long)(32767L))/LMULTI;
	if (sumr>=m_Peek_h) sumr=m_Peek_h-1;
	if (sumr>m_MaxPeekR)
	{
		m_MaxPeekR=sumr;
		m_TimeForPeekR=10;
	}
	
	for (i=0; i<m_Peek_h; i++) // Immer eine Reihe Frei...
	{
		unsigned long color1 = i*255L/m_Peek_h;
		unsigned long color2 = 255L-color1;
		for (unsigned long peekWidth=0; peekWidth<m_PeekWidth; peekWidth++)
		{
			if (i>=suml)
				dcp.SetPixel(m_PeekX1+peekWidth, m_ClientRectPeekMeter.bottom-i, RGB(color1>>1, color2>>1, 0));
			else
				dcp.SetPixel(m_PeekX1+peekWidth, m_ClientRectPeekMeter.bottom-i, RGB(color1, color2, 0));
			if (i>=sumr)
				dcp.SetPixel(m_PeekX2+peekWidth, m_ClientRectPeekMeter.bottom-i, RGB(color1>>1, color2>>1, 0));
			else
				dcp.SetPixel(m_PeekX2+peekWidth, m_ClientRectPeekMeter.bottom-i, RGB(color1, color2, 0));
		}
	}
	if (m_TimeForPeekL>0)
	{
		m_TimeForPeekL--;
		unsigned long color1 = m_MaxPeekL*255L/m_Peek_h;
		unsigned long color2 = 255L-color1;
		for (unsigned long peekWidth=0; peekWidth<m_PeekWidth; peekWidth++)
			dcp.SetPixel(m_PeekX1+peekWidth, m_ClientRectPeekMeter.bottom-m_MaxPeekL, RGB(color1, color2, 0));
	}
	else
		m_MaxPeekL=0;
	if (m_TimeForPeekR>0)
	{
		m_TimeForPeekR--;
		unsigned long color1 = m_MaxPeekR*255L/m_Peek_h;
		unsigned long color2 = 255L-color1;
		for (unsigned long peekWidth=0; peekWidth<m_PeekWidth; peekWidth++)
			dcp.SetPixel(m_PeekX2+peekWidth, m_ClientRectPeekMeter.bottom-m_MaxPeekR, RGB(color1, color2, 0));
	}
	else
		m_MaxPeekR=0;
}

void CWinModDlg::AusgabeDaten()
{
	char TrendinProzent[10];
	unsigned long vol;
	int Iconic =IsIconic();

	if (!PlayerDone && !Iconic)
	{
		sprintf(TrendinProzent,"%u%%", PlayerActTicks*100*NUM_PLAY_NOTIFICATIONS/PlayerBufferLenMillisec);
		m_CPUUTILC.SetWindowText(TrendinProzent);

		sprintf(TrendinProzent,"%02X/%02X", PlayerActPatternIndex, ThisMod->SongLength);
		m_ActPatternIndexC.SetWindowText(TrendinProzent);

		sprintf(TrendinProzent,"%02X", PlayerActPattern);
		m_ActPatternC.SetWindowText(TrendinProzent);
		
		sprintf(TrendinProzent,"%02X", PlayerActRow);
		m_ActRowC.SetWindowText(TrendinProzent);

		sprintf(TrendinProzent,"%u", BPMSpeed);
		m_ActBPMC.SetWindowText(TrendinProzent);

		sprintf(TrendinProzent,"%u", Tempo);
		m_ActSpeedC.SetWindowText(TrendinProzent);

		vol=PlayerMilliSec/1000000;
		sprintf(TrendinProzent, "%2u:%02u", vol/60, vol%60);
		m_PlayerTimeC.SetWindowText(TrendinProzent);

		// Sliderwert setzen.
		vol=m_SliderPreAmp.GetPos()*StartingVolume/512;
		if (!vol) vol=1;
		MaxVolume=vol;

		PatternDlg.DisplayActPosition(PlayerActPattern, PlayerActRow);
	}
	if (PlayList)
	{
		if (PlayNextFile && PlayerDone) NextFile=true;
		if (NextFile)
		{
			NextFile=false;
			PlayNextPiece(); 
			if (PlayerDone && !DontStart) OnButtonPlay();
		}
	}
	if (!Pause && !Iconic && !DrawNoMore) DrawBufferSample();
}

void CWinModDlg::OnButtonRW() 
{
	DoRewind(true);	
	DoFastForward(false);
}

void CWinModDlg::OnButtonPlay() 
{
	DontStart=false;
	if (PlayerFastForward)
		DoFastForward(false);
	else
	if (PlayerRewind)
		DoRewind(false);
	else
	if (Pause) OnButtonPause();
	else 
	{
		OnButtonStop();
		useWaveOut = m_InternalUseWaveOut;
		PlayerFrequ=Frequenzies[m_Combo_PlayerFrequenzy.GetCurSel()];
		PlayerBitPerSample=BitPerSamples[m_Combo_nSamples.GetCurSel()];
		PlayerChannels=Channels[m_Combo_Channels.GetCurSel()];
		PlayerBufferLenMillisec=Bufferms[m_Combo_Bufferms.GetCurSel()]*NUM_PLAY_NOTIFICATIONS;
		PlayThePiece(m_hWnd);
		DrawNoMore=false;
		if (PlayList) PlayNextFile=true; // Bei einem Listfile immer auch das nchste spielen...
	}
}

void CWinModDlg::OnButtonFF() 
{
	DoRewind(false);
	DoFastForward(true);
}

void CWinModDlg::OnButtonStop() 
{
	PlayNextFile=false;
	StopPlay();
}

void CWinModDlg::OnButtonPause() 
{
	Pause=!Pause;
	PauseBuffer(Pause);
}

void CWinModDlg::OnCheckIsp() 
{
	PlayerISP=!PlayerISP;
	m_CheckISPC.SetCheck(PlayerISP);
}

void CWinModDlg::OnCHECKlinFrequ() 
{
	PlayerUseLinearFrequency=!PlayerUseLinearFrequency;
	m_CheckUseLinearFrequency.SetCheck(PlayerUseLinearFrequency);
}

void CWinModDlg::OnCHECKUseWaveOut() 
{
	m_InternalUseWaveOut=!m_InternalUseWaveOut;
	m_UseWaveOut.SetCheck(m_InternalUseWaveOut);
}

void CWinModDlg::OnCHECKWideStereo() 
{
	PlayerWideStereo=!PlayerWideStereo;
	m_WideStereoC.SetCheck(PlayerWideStereo);
}

void CWinModDlg::OnCHECKClipping()
{
	PlayerClipping=!PlayerClipping;
	m_CheckClippingC.SetCheck(PlayerClipping);
}

void CWinModDlg::OnCHECKLoopsAllowed() 
{
	PlayerLoopsAllowed=!PlayerLoopsAllowed;
	m_CheckLoopsAllowedC.SetCheck(PlayerLoopsAllowed);
}

void CWinModDlg::OnCheckClick() 
{
	PlayerClick=!PlayerClick;
	m_CheckClickC.SetCheck(PlayerClick);
}

void CWinModDlg::OnButtonNext() 
{
	if (PlayList)
	{
		if (PlayerDone) DontStart=true;
		OnButtonStop();
		NextFile=true;
	}
}

void CWinModDlg::OnDropFiles( HDROP hDropInfo )
{
	char buffer[1024];

	int count = DragQueryFile(hDropInfo, 0, buffer, 1024);
	
	LoadaFile(buffer);
	OnButtonPlay();

	// Speicher wieder freigeben...
	DragFinish(hDropInfo);
}

void CWinModDlg::prepareClose()
{
	StopPlay();
	writeConfigToRegistry();
}

void CWinModDlg::OnCancel()
{
	prepareClose();
	CDialog::OnCancel();
}
void CWinModDlg::OnOK()
{
	prepareClose();
	CDialog::OnOK();
}